=begin
#Hydrogen Integration API

#The Hydrogen Integration API

OpenAPI spec version: 1.2.1
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.18

=end

require 'uri'

module IntegrationApi
  class MarketDataApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create historical market data
    # @param history_request historyRequest
    # @param [Hash] opts the optional parameters
    # @return [MdHistoryResponseVO]
    def create_market_data_historical_using_post(history_request, opts = {})
      data, _status_code, _headers = create_market_data_historical_using_post_with_http_info(history_request, opts)
      data
    end

    # Create historical market data
    # @param history_request historyRequest
    # @param [Hash] opts the optional parameters
    # @return [Array<(MdHistoryResponseVO, Fixnum, Hash)>] MdHistoryResponseVO data, response status code and response headers
    def create_market_data_historical_using_post_with_http_info(history_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MarketDataApi.create_market_data_historical_using_post ...'
      end
      # verify the required parameter 'history_request' is set
      if @api_client.config.client_side_validation && history_request.nil?
        fail ArgumentError, "Missing the required parameter 'history_request' when calling MarketDataApi.create_market_data_historical_using_post"
      end
      # resource path
      local_var_path = '/market_data/historical'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(history_request)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'MdHistoryResponseVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MarketDataApi#create_market_data_historical_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create quote market data
    # @param quote_request quoteRequest
    # @param [Hash] opts the optional parameters
    # @return [MdQuoteResponseVO]
    def create_market_data_quote_using_post(quote_request, opts = {})
      data, _status_code, _headers = create_market_data_quote_using_post_with_http_info(quote_request, opts)
      data
    end

    # Create quote market data
    # @param quote_request quoteRequest
    # @param [Hash] opts the optional parameters
    # @return [Array<(MdQuoteResponseVO, Fixnum, Hash)>] MdQuoteResponseVO data, response status code and response headers
    def create_market_data_quote_using_post_with_http_info(quote_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: MarketDataApi.create_market_data_quote_using_post ...'
      end
      # verify the required parameter 'quote_request' is set
      if @api_client.config.client_side_validation && quote_request.nil?
        fail ArgumentError, "Missing the required parameter 'quote_request' when calling MarketDataApi.create_market_data_quote_using_post"
      end
      # resource path
      local_var_path = '/market_data/quote'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(quote_request)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'MdQuoteResponseVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: MarketDataApi#create_market_data_quote_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
