=begin
#Hydrogen Integration API

#The Hydrogen Integration API

OpenAPI spec version: 1.2.1
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.18

=end

require 'uri'

module IntegrationApi
  class UtilsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Retrieve token based on certain vendor specific value
    # Retrieve the token.
    # @param exchange_token_co exchangeTokenCO
    # @param [Hash] opts the optional parameters
    # @return [ExchangePublicTokenVO]
    def create_token_exchange_using_post(exchange_token_co, opts = {})
      data, _status_code, _headers = create_token_exchange_using_post_with_http_info(exchange_token_co, opts)
      data
    end

    # Retrieve token based on certain vendor specific value
    # Retrieve the token.
    # @param exchange_token_co exchangeTokenCO
    # @param [Hash] opts the optional parameters
    # @return [Array<(ExchangePublicTokenVO, Fixnum, Hash)>] ExchangePublicTokenVO data, response status code and response headers
    def create_token_exchange_using_post_with_http_info(exchange_token_co, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UtilsApi.create_token_exchange_using_post ...'
      end
      # verify the required parameter 'exchange_token_co' is set
      if @api_client.config.client_side_validation && exchange_token_co.nil?
        fail ArgumentError, "Missing the required parameter 'exchange_token_co' when calling UtilsApi.create_token_exchange_using_post"
      end
      # resource path
      local_var_path = '/token_exchange'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(exchange_token_co)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ExchangePublicTokenVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UtilsApi#create_token_exchange_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create user in vendor
    # Create user in vendor.
    # @param create_user_request createUserRequest
    # @param [Hash] opts the optional parameters
    # @return [UserResponseVO]
    def create_user_using_post(create_user_request, opts = {})
      data, _status_code, _headers = create_user_using_post_with_http_info(create_user_request, opts)
      data
    end

    # Create user in vendor
    # Create user in vendor.
    # @param create_user_request createUserRequest
    # @param [Hash] opts the optional parameters
    # @return [Array<(UserResponseVO, Fixnum, Hash)>] UserResponseVO data, response status code and response headers
    def create_user_using_post_with_http_info(create_user_request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UtilsApi.create_user_using_post ...'
      end
      # verify the required parameter 'create_user_request' is set
      if @api_client.config.client_side_validation && create_user_request.nil?
        fail ArgumentError, "Missing the required parameter 'create_user_request' when calling UtilsApi.create_user_using_post"
      end
      # resource path
      local_var_path = '/user'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(create_user_request)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'UserResponseVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UtilsApi#create_user_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Gel all audit log
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending (default to false)
    # @option opts [DateTime] :end_date end_date (default to null)
    # @option opts [String] :event event
    # @option opts [String] :integration_type integration_type
    # @option opts [BOOLEAN] :is_request is_request (default to false)
    # @option opts [String] :nucleus_client_id nucleus_client_id
    # @option opts [String] :order_by order_by (default to update_date)
    # @option opts [Integer] :page page (default to 0)
    # @option opts [String] :request_type request_type
    # @option opts [Integer] :size size (default to 25)
    # @option opts [DateTime] :start_date start_date (default to null)
    # @option opts [String] :vendor_name vendor_name
    # @return [Pageobject]
    def get_audit_log_all_using_get(opts = {})
      data, _status_code, _headers = get_audit_log_all_using_get_with_http_info(opts)
      data
    end

    # Gel all audit log
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :ascending ascending
    # @option opts [DateTime] :end_date end_date
    # @option opts [String] :event event
    # @option opts [String] :integration_type integration_type
    # @option opts [BOOLEAN] :is_request is_request
    # @option opts [String] :nucleus_client_id nucleus_client_id
    # @option opts [String] :order_by order_by
    # @option opts [Integer] :page page
    # @option opts [String] :request_type request_type
    # @option opts [Integer] :size size
    # @option opts [DateTime] :start_date start_date
    # @option opts [String] :vendor_name vendor_name
    # @return [Array<(Pageobject, Fixnum, Hash)>] Pageobject data, response status code and response headers
    def get_audit_log_all_using_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UtilsApi.get_audit_log_all_using_get ...'
      end
      # resource path
      local_var_path = '/audit_log'

      # query parameters
      query_params = {}
      query_params[:'ascending'] = opts[:'ascending'] if !opts[:'ascending'].nil?
      query_params[:'end_date'] = opts[:'end_date'] if !opts[:'end_date'].nil?
      query_params[:'event'] = opts[:'event'] if !opts[:'event'].nil?
      query_params[:'integration_type'] = opts[:'integration_type'] if !opts[:'integration_type'].nil?
      query_params[:'is_request'] = opts[:'is_request'] if !opts[:'is_request'].nil?
      query_params[:'nucleus_client_id'] = opts[:'nucleus_client_id'] if !opts[:'nucleus_client_id'].nil?
      query_params[:'order_by'] = opts[:'order_by'] if !opts[:'order_by'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'request_type'] = opts[:'request_type'] if !opts[:'request_type'].nil?
      query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
      query_params[:'start_date'] = opts[:'start_date'] if !opts[:'start_date'].nil?
      query_params[:'vendor_name'] = opts[:'vendor_name'] if !opts[:'vendor_name'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Pageobject')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UtilsApi#get_audit_log_all_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve widget link
    # Retrieve the widget link.
    # @param nucleus_client_id nucleus_client_id
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :is_mobile_webview is_mobile_webview (default to false)
    # @option opts [String] :mode mode (default to aggregation)
    # @option opts [String] :vendor_name vendor_name
    # @return [WidgetUrlVO]
    def get_widget_link_using_get(nucleus_client_id, opts = {})
      data, _status_code, _headers = get_widget_link_using_get_with_http_info(nucleus_client_id, opts)
      data
    end

    # Retrieve widget link
    # Retrieve the widget link.
    # @param nucleus_client_id nucleus_client_id
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :is_mobile_webview is_mobile_webview
    # @option opts [String] :mode mode
    # @option opts [String] :vendor_name vendor_name
    # @return [Array<(WidgetUrlVO, Fixnum, Hash)>] WidgetUrlVO data, response status code and response headers
    def get_widget_link_using_get_with_http_info(nucleus_client_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: UtilsApi.get_widget_link_using_get ...'
      end
      # verify the required parameter 'nucleus_client_id' is set
      if @api_client.config.client_side_validation && nucleus_client_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_client_id' when calling UtilsApi.get_widget_link_using_get"
      end
      # resource path
      local_var_path = '/widget_link/{nucleus_client_id}'.sub('{' + 'nucleus_client_id' + '}', nucleus_client_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'is_mobile_webview'] = opts[:'is_mobile_webview'] if !opts[:'is_mobile_webview'].nil?
      query_params[:'mode'] = opts[:'mode'] if !opts[:'mode'].nil?
      query_params[:'vendor_name'] = opts[:'vendor_name'] if !opts[:'vendor_name'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'WidgetUrlVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: UtilsApi#get_widget_link_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
