=begin
#Hydrogen Integration API

#The Hydrogen Integration API

OpenAPI spec version: 1.2.1
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.18

=end

require 'date'

module IntegrationApi
  # BankLink Object
  class BankLink
    # accountId
    attr_accessor :account_id

    # available_balance
    attr_accessor :available_balance

    # balance
    attr_accessor :balance

    # bankAccountHolder
    attr_accessor :bank_account_holder

    # bankAccountName
    attr_accessor :bank_account_name

    # bankAccountNumber
    attr_accessor :bank_account_number

    # Bank link Client Id 
    attr_accessor :client_id

    attr_accessor :create_date

    # currency_code
    attr_accessor :currency_code

    attr_accessor :id

    # isActive
    attr_accessor :is_active

    # isDefault
    attr_accessor :is_default

    # isLinkVerified
    attr_accessor :is_link_verified

    # linkVerifiedDate
    attr_accessor :link_verified_date

    # mask
    attr_accessor :mask

    # metadata
    attr_accessor :metadata

    # name
    attr_accessor :name

    # routing
    attr_accessor :routing

    # routing_wire
    attr_accessor :routing_wire

    attr_accessor :secondary_id

    # type
    attr_accessor :type

    attr_accessor :update_date

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'account_id' => :'account_id',
        :'available_balance' => :'available_balance',
        :'balance' => :'balance',
        :'bank_account_holder' => :'bank_account_holder',
        :'bank_account_name' => :'bank_account_name',
        :'bank_account_number' => :'bank_account_number',
        :'client_id' => :'client_id',
        :'create_date' => :'create_date',
        :'currency_code' => :'currency_code',
        :'id' => :'id',
        :'is_active' => :'is_active',
        :'is_default' => :'is_default',
        :'is_link_verified' => :'is_link_verified',
        :'link_verified_date' => :'link_verified_date',
        :'mask' => :'mask',
        :'metadata' => :'metadata',
        :'name' => :'name',
        :'routing' => :'routing',
        :'routing_wire' => :'routing_wire',
        :'secondary_id' => :'secondary_id',
        :'type' => :'type',
        :'update_date' => :'update_date'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'account_id' => :'String',
        :'available_balance' => :'Float',
        :'balance' => :'Float',
        :'bank_account_holder' => :'String',
        :'bank_account_name' => :'String',
        :'bank_account_number' => :'String',
        :'client_id' => :'String',
        :'create_date' => :'DateTime',
        :'currency_code' => :'String',
        :'id' => :'String',
        :'is_active' => :'BOOLEAN',
        :'is_default' => :'BOOLEAN',
        :'is_link_verified' => :'BOOLEAN',
        :'link_verified_date' => :'Date',
        :'mask' => :'String',
        :'metadata' => :'Hash<String, String>',
        :'name' => :'String',
        :'routing' => :'String',
        :'routing_wire' => :'String',
        :'secondary_id' => :'String',
        :'type' => :'String',
        :'update_date' => :'DateTime'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'account_id')
        self.account_id = attributes[:'account_id']
      end

      if attributes.has_key?(:'available_balance')
        self.available_balance = attributes[:'available_balance']
      end

      if attributes.has_key?(:'balance')
        self.balance = attributes[:'balance']
      end

      if attributes.has_key?(:'bank_account_holder')
        self.bank_account_holder = attributes[:'bank_account_holder']
      end

      if attributes.has_key?(:'bank_account_name')
        self.bank_account_name = attributes[:'bank_account_name']
      end

      if attributes.has_key?(:'bank_account_number')
        self.bank_account_number = attributes[:'bank_account_number']
      end

      if attributes.has_key?(:'client_id')
        self.client_id = attributes[:'client_id']
      end

      if attributes.has_key?(:'create_date')
        self.create_date = attributes[:'create_date']
      end

      if attributes.has_key?(:'currency_code')
        self.currency_code = attributes[:'currency_code']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'is_active')
        self.is_active = attributes[:'is_active']
      end

      if attributes.has_key?(:'is_default')
        self.is_default = attributes[:'is_default']
      end

      if attributes.has_key?(:'is_link_verified')
        self.is_link_verified = attributes[:'is_link_verified']
      end

      if attributes.has_key?(:'link_verified_date')
        self.link_verified_date = attributes[:'link_verified_date']
      end

      if attributes.has_key?(:'mask')
        self.mask = attributes[:'mask']
      end

      if attributes.has_key?(:'metadata')
        if (value = attributes[:'metadata']).is_a?(Hash)
          self.metadata = value
        end
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'routing')
        self.routing = attributes[:'routing']
      end

      if attributes.has_key?(:'routing_wire')
        self.routing_wire = attributes[:'routing_wire']
      end

      if attributes.has_key?(:'secondary_id')
        self.secondary_id = attributes[:'secondary_id']
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.has_key?(:'update_date')
        self.update_date = attributes[:'update_date']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @bank_account_holder.nil?
        invalid_properties.push('invalid value for "bank_account_holder", bank_account_holder cannot be nil.')
      end

      if @bank_account_number.nil?
        invalid_properties.push('invalid value for "bank_account_number", bank_account_number cannot be nil.')
      end

      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @routing.nil?
        invalid_properties.push('invalid value for "routing", routing cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @bank_account_holder.nil?
      return false if @bank_account_number.nil?
      return false if @name.nil?
      return false if @routing.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          account_id == o.account_id &&
          available_balance == o.available_balance &&
          balance == o.balance &&
          bank_account_holder == o.bank_account_holder &&
          bank_account_name == o.bank_account_name &&
          bank_account_number == o.bank_account_number &&
          client_id == o.client_id &&
          create_date == o.create_date &&
          currency_code == o.currency_code &&
          id == o.id &&
          is_active == o.is_active &&
          is_default == o.is_default &&
          is_link_verified == o.is_link_verified &&
          link_verified_date == o.link_verified_date &&
          mask == o.mask &&
          metadata == o.metadata &&
          name == o.name &&
          routing == o.routing &&
          routing_wire == o.routing_wire &&
          secondary_id == o.secondary_id &&
          type == o.type &&
          update_date == o.update_date
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [account_id, available_balance, balance, bank_account_holder, bank_account_name, bank_account_number, client_id, create_date, currency_code, id, is_active, is_default, is_link_verified, link_verified_date, mask, metadata, name, routing, routing_wire, secondary_id, type, update_date].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        (value)
      when :Date
        (value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = IntegrationApi.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
